---
title: delete operator
slug: Web/JavaScript/Reference/Operators/delete
tags:
  - JavaScript
  - Language feature
  - Memory Management
  - Object
  - Operator
  - Reference
  - Release
  - Unary
  - delete
---
<div>{{jsSidebar("Operators")}}</div>

<p><span class="seoSummary">The JavaScript <strong><code>delete</code> operator</strong> removes a property from an object; if no more references to the same property are held, it is eventually released automatically.</span></p>

<div>{{EmbedInteractiveExample("pages/js/expressions-deleteoperator.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">delete <var>expression</var> </pre>

<p>Where <code><var>expression</var></code> should evaluate to a <a href="/en-US/docs/Glossary/property/JavaScript">property</a> reference, e.g.:</p>

<pre class="syntaxbox">delete <var>object</var>.<var>property</var>
delete <var>object</var>['<var>property</var>']
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
	<dt><code><var>object</var></code></dt>
	<dd>The name of an object, or an expression evaluating to an object.</dd>
	<dt><code><var>property</var></code></dt>
	<dd>The property to delete.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p><code>true</code> for all cases except when the property is an {{jsxref("Object.hasOwnProperty", "own")}} {{jsxref("Errors/Cant_delete", "non-configurable")}} property, in which case, <code>false</code> is returned in non-strict mode.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>Throws {{jsxref("TypeError")}} in {{jsxref("Functions_and_function_scope/Strict_mode", "strict mode")}} if the property is an own non-configurable property.</p>

<h2 id="Description">Description</h2>

<p>Unlike what common belief suggests (perhaps due to other programming languages like <a href="https://docs.microsoft.com/en-us/cpp/cpp/delete-operator-cpp?view=vs-2019">delete in C++</a>), the <code>delete</code> operator has <strong>nothing</strong> to do with directly freeing memory. Memory management is done indirectly via breaking references. See the <a href="/en-US/docs/Web/JavaScript/Memory_Management">memory management</a> page for more details.</p>

<p>The <code><strong>delete</strong></code> operator removes a given property from an object. On successful deletion, it will return <code>true</code>, else <code>false</code> will be returned.</p>

<p>However, it is important to consider the following scenarios:</p>

<ul>
	<li>If the property which you are trying to delete does not exist, <code>delete</code> will not have any effect and will return <code>true</code>.</li>
	<li>If a property with the same name exists on the object's prototype chain, then, after deletion, the object will use the property from the prototype chain (in other words, <code>delete</code> only has an effect on own properties).</li>
	<li>Any property declared with {{jsxref("Statements/var","var")}} cannot be deleted from the global scope or from a function's scope.
	<ul>
		<li>As such, <code>delete</code> cannot delete any functions in the global scope (whether this is part from a function definition or a function expression).</li>
		<li>Functions which are part of an object (apart from the global scope) can be deleted with <code>delete</code>.</li>
	</ul>
	</li>
	<li>Any property declared with {{jsxref("Statements/let","let")}} or {{jsxref("Statements/const","const")}} cannot be deleted from the scope within which they were defined.</li>
	<li>Non-configurable properties cannot be removed. This includes properties of built-in objects like {{jsxref("Math")}}, {{jsxref("Array")}}, {{jsxref("Object")}} and properties that are created as non-configurable with methods like {{jsxref("Object.defineProperty()")}}.</li>
</ul>

<p>The following snippet gives a simple example:</p>

<pre class="brush: js">var Employee = {
  age: 28,
  name: 'abc',
  designation: 'developer'
}

console.log(delete Employee.name);   // returns true
console.log(delete Employee.age);    // returns true

// When trying to delete a property that does
// not exist, true is returned
console.log(delete Employee.salary); // returns true
</pre>

<h3 id="Non-configurable_properties">Non-configurable properties</h3>

<p>When a property is marked as non-configurable, <code>delete</code> won't have any effect, and will return <code>false</code>. In strict mode this will raise a <code>TypeError</code>.</p>

<pre class="brush: js">var Employee = {};
Object.defineProperty(Employee, 'name', {configurable: false});

console.log(delete Employee.name);  // returns false
</pre>

<p>{{jsxref("Statements/var","var")}}, {{jsxref("Statements/let","let")}}, and {{jsxref("Statements/const","const")}} create non-configurable properties that cannot be deleted with the <code>delete</code> operator:</p>

<pre class="brush: js">var nameOther = 'XYZ';

// We can access this global property using:
Object.getOwnPropertyDescriptor(window, 'nameOther');

// output: Object {value: "XYZ",
//                  writable: true,
//                  enumerable: true,
//                  <strong>configurable: false</strong>}

// Since "nameOther" is added using with the
// var keyword, it is marked as "non-configurable"

delete nameOther;   // return false</pre>

<p>In strict mode, this would have raised an exception.</p>

<h3 id="Strict_vs._non-strict_mode">Strict vs. non-strict mode</h3>

<p>When in strict mode, if <code>delete</code> is used on a direct reference to a variable, a function argument or a function name, it will throw a {{jsxref("SyntaxError")}}<strong>. </strong>Therefore, to avoid syntax errors in strict mode, you must use the <code>delete</code> operator in the form of <code>delete object.property</code> or <code>delete object['property']</code>.</p>

<pre class="brush: js">Object.defineProperty(globalThis, 'variable1', { value: 10, configurable: true, });
Object.defineProperty(globalThis, 'variable2', { value: 10, configurable: false, });

// SyntaxError in strict mode.
console.log(delete variable1); // true

// SyntaxError in strict mode.
console.log(delete variable2); // false
</pre>

<pre class="brush: js">function func(param) {
  // SyntaxError in strict mode.
  console.log(delete param); // false
}

// SyntaxError in strict mode.
console.log(delete func); // false
</pre>

<h3 id="Cross-browser_notes">Cross-browser notes</h3>

<p>Although ECMAScript makes iteration order of objects implementation-dependent, it may appear that all major browsers support an iteration order based on the earliest added property coming first (at least for properties not on the prototype). However, in the case of Internet Explorer, when one uses <code>delete</code> on a property, some confusing behavior results, preventing other browsers from using simple objects like object literals as ordered associative arrays. In Explorer, while the property <em>value</em> is indeed set to <code>undefined</code>, if one later adds back a property with the same name, the property will be iterated in its <em>old</em> position--not at the end of the iteration sequence as one might expect after having deleted the property and then added it back.</p>

<p>If you want to use an ordered associative array in a cross-browser environment, use a {{jsxref("Map")}} object if available, or simulate this structure with two separate arrays (one for the keys and the other for the values), or build an array of single-property objects, etc.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">// Creates the property adminName on the global scope.
adminName = 'xyz';

// Creates the property empCount on the global scope.
// Since we are using var, this is marked as non-configurable. The same is true of let and const.
var empCount = 43;

EmployeeDetails = {
  name: 'xyz',
  age: 5,
  designation: 'Developer'
};

// adminName is a property of the global scope.
// It can be deleted since it is created without var,
// and is therefore configurable.
delete adminName;       // returns true

// On the contrary, empCount is not configurable
// since var was used.
delete empCount;       // returns false

// delete can be used to remove properties from objects.
delete EmployeeDetails.name; // returns true

<strong>// </strong>Even when the property does not exist, delete returns "true".
delete EmployeeDetails.salary; // returns true

// delete does not affect built-in static properties.
delete Math.PI; // returns false

// EmployeeDetails is a property of the global scope.
// Since it was defined without "var", it is marked configurable.
delete EmployeeDetails;   // returns true

function f() {
  var z = 44;

  // delete doesn't affect local variable names
  delete z;     // returns false
}
</pre>

<h3 id="delete_and_the_prototype_chain"><code>delete</code> and the prototype chain</h3>

<p>In the following example, we delete an own property of an object while a property with the same name is available on the prototype chain:</p>

<pre class="brush: js">function Foo() {
  this.bar = 10;
}

Foo.prototype.bar = 42;

var foo = new Foo();

// foo.bar is associated with the
// own property.
console.log(foo.bar); // 10

// Delete the own property within the
// foo object.
delete foo.bar; // returns true

// foo.bar is still available in the
// prototype chain.
console.log(foo.bar); // 42

// Delete the property on the prototype.
delete Foo.prototype.bar; // returns true

// The "bar" property can no longer be
// inherited from Foo since it has been
// deleted.
console.log(foo.bar); // undefined</pre>

<h3 id="Deleting_array_elements">Deleting array elements</h3>

<p>When you delete an array element, the array <code>length</code> is not affected. This holds even if you delete the last element of the array.</p>

<p>When the <code>delete</code> operator removes an array element, that element is no longer in the array. In the following example, <code>trees[3]</code> is removed with <code>delete</code>.</p>

<pre class="brush: js">var trees = ['redwood', 'bay', 'cedar', 'oak', 'maple'];
delete trees[3];
if (3 in trees) {
    // this is not executed
}</pre>

<p>If you want an array element to exist but have an undefined value, use the <code>undefined</code> value instead of the <code>delete</code> operator. In the following example, <code>trees[3]</code> is assigned the value <code>undefined</code>, but the array element still exists:</p>

<pre class="brush: js">var trees = ['redwood', 'bay', 'cedar', 'oak', 'maple'];
trees[3] = undefined;
if (3 in trees) {
    // this is executed
}</pre>

<p>If instead, you want to remove an array element by changing the contents of the array, use the {{jsxref("Array.splice()", "splice()")}} method. In the following example, <code>trees[3]</code> is removed from the array completely using {{jsxref("Array.splice()", "splice()")}}:</p>

<pre class="brush: js">var trees = ['redwood', 'bay', 'cedar', 'oak', 'maple'];
trees.splice(3,1);
console.log(trees); // ["redwood", "bay", "cedar", "maple"]
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName('ESDraft', '#sec-delete-operator', 'The delete Operator')}}</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.operators.delete")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="http://perfectionkills.com/understanding-delete/">In depth analysis on delete</a></li>
	<li>{{jsxref("Reflect.deleteProperty()")}}</li>
	<li>{{jsxref("Map.prototype.delete()")}}</li>
</ul>
